#include "modlibgccvb.h"  // gccVB library
#include "notes.h"     // Note constants by DanB
#include "su11sfx.h"   // Sound engine header
#include "su11sfx.c"   // Sound engine implementation
#include "sounddat.h"  // Actual sounds
#include "titlescreenchar.h"
#include "titlescreenmap.h"
#include "cranberry6char.h"
#include "cranberry6map.h"
#include "font_fixed_cranberry.h"
#include "level1char.h"
#include "level1map.h"
#include "stageintrochar.h"
#include "stageintromap.h"
#include "craigintrobgchar.h"
#include "craigintrobgmap.h"
#include "hole2char.h"
#include "hole2map.h"

int craigx=180, craigy=190, bgmap=1, craigcutx=0, craigcuty=0, craigdir=0, cloudx=444, holex;
int bg1x=0, bg2x=384, bg1cuty=95, bg2cuty=126, bg3x=0, bg3cuty=0, bg4x=384, bg4cuty=24;
int enemyx, enemyy, enemyxcutx, enemyycuty, enemyytotaly;
int enemyboundary=0, holexminussixteen, enemyxminus, enemyxplus, enemyyminus, holewidth, holexplus, holey=194;
int bg3y, bg4y, enemygravity;
unsigned char enemyanimtimer, enemydir, enemynumber=0, meter, enemyxtotalx, enemydir1;
unsigned char gamepart=0, cloudy=100, cloudtimer, craigmovetimer, rolltimer=0, rollpos=0, jumptimer=0;
unsigned char gravity=0, jumpaheld=0, startpressed=0, craigxtempo, fallinhole, lives, hurttimer=0, iblockhit=0, enemytype;
char lives_str[1];

int main()
{
while (gamepart==0)
	{
	vbSetWorld(31, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0); 
	vbSetWorld(30, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0); 	
	vbSetWorld(29, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0); 
	vbSetWorld(28, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0); 
	vbSetWorld(27, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0); 	
	vbSetWorld(26, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0); 
	vbSetWorld(25, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0); 	
	vbSetWorld(24, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0); 
	vbSetWorld(23, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0); 
	vbSetWorld(22, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0); 
	vbSetWorld(21, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0); 	
	
	copymem((void*)CharSeg0, (void*)CRANBERRY6CHAR, 512*16);
	copymem((void*)BGMap(0), (void*)CRANBERRY6MAP, 512*16);	
	
	copymem((void*)CharSeg1, (void*)TITLESCREENCHAR, 512*16);
	copymem((void*)BGMap(1), (void*)TITLESCREENMAP, 512*16);	
	
	copymem((void*)CharSeg2, (void*)HOLE2CHAR, 512*16);
	copymem((void*)BGMap(2), (void*)HOLE2MAP, 512*16);		

	copymem((void*)CharSeg3, (void*)FONT_FIXED_CRANBERRY, 512*16);
	copymem((void*)BGMap(3), (void*)HOLE2MAP, 512*16);	

	VIP_REGS[GPLT1]=0x24;	

	vbSetWorld(20, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 2, 3); 
	
	vbTextOut(1,18,6,"*2020, chris read.");
	// i changed * to be copyright symbol.
	// health meter - full block is semicolon, empty block is <

	vbSetWorld(31, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 384, 56); 	// title words
	vbSetWorld(30, WRLD_ON|1, 0, 0, 164, 0, 0, 112, 384, 50); 

	vbDisplayOn();	
	vbDisplayShow();
	
	InitSound();
	
	craigxtempo=2;
	PlaySound(titlescreen);	
	PlaySound(titlescreen2);	

	gamepart=1;
	}

while(gamepart==1)
	{
	VIP_REGS[GPLT1]=0x24;	
	
    // wait for the VIP to finish drawing
    while(!(VIP_REGS[INTPND] & XPEND)); 
    VIP_REGS[INTCLR]= XPEND; 

	DoSounds();		

	lives=3;	
	
	vbSetWorld(29, WRLD_ON|1, 0, 0, 194, 0, 0, 74, 384, 30); 		
	vbSetWorld(28, WRLD_ON, craigx, 0, craigy, craigcutx, 0, craigcuty, 15, 15); 				
	vbSetWorld(27, WRLD_ON|1, 0, 0, 200, 0, 0, 180, 384, 24); 	

	vbSetWorld(20, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 2, 3); 

	// move those clouds.
	vbSetWorld(26, WRLD_ON|1, cloudx, 0, cloudy, 0, 0, 56, 384, 16); 	

	// slow the thing down so it's equal.
	if (vbReadPad()&K_A) moving(), moving();	

	cloudtimer++;
	if (cloudtimer>2) cloudx--, cloudtimer=0;
	if (cloudx<-275) cloudx=400, cloudy++;
	if (cloudy>110) cloudy=100;	

	controls();
	if (jumptimer==1) PlaySound(jump);	

	if ((vbReadPad()&K_STA) && (startpressed==0)) startpressed=1;
	if (!(vbReadPad()&K_STA) && (startpressed==1)) startpressed=0, gamepart=2;
	}
	
while(gamepart==2)
	{	
	vbSetWorld(31, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 0, 0); 
	vbSetWorld(30, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 0, 0); 			
	vbSetWorld(29, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 0, 0); 
	vbSetWorld(28, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 0, 0); 	
	vbSetWorld(27, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 0, 0); 		
	
	copymem((void*)CharSeg2, (void*)CRAIGINTROBGCHAR, 256*16);
	copymem((void*)BGMap(2), (void*)CRAIGINTROBGMAP, 256*16);			

	bg3x=-56, bg3y=-56, bg4x=56, bg4y=56;

	copymem((void*)CharSeg1, (void*)STAGEINTROCHAR, 512*16);
	copymem((void*)BGMap(1), (void*)STAGEINTROMAP, 512*16);		
	
	vbSetWorld(23, WRLD_ON|1, 0, 0, 8, 0, 0, 8, 384, 216); 	// words
	vbSetWorld(22, WRLD_ON|3, 192, 0, 80, 0, 0, 0, 7, 8); 	
	vbSetWorld(21, WRLD_ON|1, 160, 0, 136, 0, 0, 0, 55, 8); 
	enemyxtotalx=15;

	enemynumber=1;
	enemydir=1;
	vbTextOut(3,0,0,"1");	
	vbTextOut(1,0,0,"meadow.");		
	
	StopAllSounds();
	PlaySound(stageintrosong);	
	PlaySound(stageintrosong2);	
	PlaySound(stageintrosong3);		
	
	gamepart=3;
	}

while(gamepart==3)
	{		
    // wait for the VIP to finish drawing
    while(!(VIP_REGS[INTPND] & XPEND)); 
    VIP_REGS[INTCLR]= XPEND; 	
	
	vbSetWorld(28, WRLD_ON|2, bg3x, 0, bg3y, 0, 0, 0, 384, 224); 	
	vbSetWorld(27, WRLD_ON|2, bg4x, 0, bg3y, 0, 0, 0, 384, 224); 	
	vbSetWorld(26, WRLD_ON|2, bg3x, 0, bg4y, 0, 0, 0, 384, 224);  	
	vbSetWorld(25, WRLD_ON|2, bg4x, 0, bg4y, 0, 0, 0, 384, 224); 
	
	bg4x++, bg4y--;
	bg3x++, bg3y--;
	DoSounds();	
	
	if (bg3x==0) bg3x=-56, bg3y=-56, bg4x=56, bg4y=56;

	if ((vbReadPad()&K_STA) && (startpressed==0)) startpressed=1;
	if (!(vbReadPad()&K_STA) && (startpressed==1)) 
	{
    // wait for the VIP to finish drawing
    while(!(VIP_REGS[INTPND] & XPEND)); 
    // clear flag
    VIP_REGS[INTCLR]= XPEND; 	

	vbSetWorld(31, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0); 
	vbSetWorld(30, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0); 	
	vbSetWorld(29, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0); 
	vbSetWorld(28, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0); 
	vbSetWorld(27, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0); 	
	vbSetWorld(26, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0); 
	vbSetWorld(25, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0); 	
	vbSetWorld(24, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0); 
	vbSetWorld(23, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0); 
	vbSetWorld(22, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0); 
	vbSetWorld(21, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0); 	
	
	craigx=20, craigy=190;	
	
	bg2x=384, bg3x=0, bg4x=384;

	copymem((void*)CharSeg1, (void*)LEVEL1CHAR, 512*16);
	copymem((void*)BGMap(1), (void*)LEVEL1MAP, 512*16);	

	copymem((void*)CharSeg2, (void*)HOLE2CHAR, 512*16);
	copymem((void*)BGMap(2), (void*)HOLE2MAP, 512*16);	

	vbSetWorld(26, WRLD_ON|1, 0, 0, 194, 0, 0, 64, 384, 31); 	
	
	StopAllSounds();
	PlaySound(levelone1);	
	PlaySound(levelone2);
	
	jumpaheld=0, craigxtempo=1;
	holex=500, enemyy=175, enemyx=400;
	holewidth=32;		
	
	enemyycuty=64;
	
	meter=22;
	vbTextOut(3,9,0,"health - ;;;;");	
	
	vbSetWorld(31, WRLD_ON|3, 104, 0, 8, 0, 0, 0, 175, 7); 	// title words	
	
	lives_str[0]=(lives%10)+'0';	
	vbTextOut(3,0,0,": - ");	
	vbTextOut(3,4,0,lives_str);
	vbTextOut(3,5,0,"    ");	
	
	vbSetWorld(24, WRLD_ON, craigx, 0, craigy, craigcutx, 0, craigcuty, 15, 15); 		
	vbSetWorld(23, WRLD_ON, enemyx, 0, enemyy, enemyxcutx, 0, enemyycuty, enemyxtotalx, enemyytotaly); 		
	
	vbSetWorld(30, WRLD_ON|1, bg3x, 0, 50, 0, 0, bg3cuty, 384, 23); 	// clouds
	vbSetWorld(29, WRLD_ON|1, bg4x, 0, 50, 0, 0, bg4cuty, 384, 23); 	// clouds
	vbSetWorld(28, WRLD_ON|1, bg1x, 0, 174, 0, 0, 95, 384, 31); 	
	vbSetWorld(27, WRLD_ON|1, bg2x, 0, 174, 0, 0, 95, 384, 31);
			
	vbSetWorld(25, WRLD_ON|2, holex, 0, holey, 0, 0, 0, holewidth, 40); 	
	vbSetWorld(22, WRLD_ON|1, bg1x, 0, 200, 0, 0, bg2cuty, 384, 31); 		
	vbSetWorld(21, WRLD_ON|1, bg2x, 0, 200, 0, 0, bg2cuty, 384, 31); 	
	
	gamepart=4;
	}
	DoSounds();
	}
	
while(gamepart==4)
	{
	if (lives==255) gamepart=0;	

    // wait for the VIP to finish drawing
    while(!(VIP_REGS[INTPND] & XPEND)); 
    // clear flag
    VIP_REGS[INTCLR]= XPEND; 
 
	craigdir=0;
 
	DoSounds();	

	vbSetWorld(24, WRLD_ON, craigx, 0, craigy, craigcutx, 0, craigcuty, 15, 15); 		
	vbSetWorld(23, WRLD_ON, enemyx, 0, enemyy, enemyxcutx, 0, enemyycuty, enemyxtotalx, enemyytotaly); 		
	
	vbSetWorld(30, WRLD_ON|1, bg3x, 0, 50, 0, 0, bg3cuty, 384, 23); 	// clouds
	vbSetWorld(29, WRLD_ON|1, bg4x, 0, 50, 0, 0, bg4cuty, 384, 23); 	// clouds
	vbSetWorld(28, WRLD_ON|1, bg1x, 0, 174, 0, 0, bg1cuty, 384, 31); 	
	vbSetWorld(27, WRLD_ON|1, bg2x, 0, 174, 0, 0, bg1cuty, 384, 31);
			
	vbSetWorld(25, WRLD_ON|2, holex, 0, holey, 0, 0, 0, holewidth, 40); 	
	vbSetWorld(22, WRLD_ON|1, bg1x, 0, 200, 0, 0, bg2cuty, 384, 31); 		
	vbSetWorld(21, WRLD_ON|1, bg2x, 0, 200, 0, 0, bg2cuty, 384, 31); 	
	
	controls();
	if (jumptimer==1) PlaySound(jump);
	if ((craigy>189) && (craigx>holex) && (craigx<holex+24) && (holey<400)) fallinhole=1;
	
	// enemytype- 1=strawberry, 2=item block, 3=cherry, 4=banana
	switch (enemynumber)
	{
	case 1:
	enemyytotaly=31, enemytype=1;
	if (holex<-96) holex=400, enemyx=500, enemynumber=2;
	break;
	
	case 2:
	if ((craigy>189) && (craigx>holex+120) && (craigx<holex+144)) fallinhole=1;
	if (holex<-196) holex=400, enemyx=500, enemyxcutx=64, enemynumber=3, enemytype=2;	
	break;	
	
	case 3:
	enemyytotaly=16, holewidth=0;
	if (enemyx<-96) enemydir=1, enemyy=156, enemyx=400, enemyanimtimer=210, enemynumber=4, enemytype=3;
	break;
	
	case 4:
	enemyytotaly=38, holewidth=32;
	if (holex<-100) holex=400, enemyx=400, enemydir=0, enemydir1=1, enemytype=4, enemynumber=5;
	break;	
	
	case 5:
	enemyytotaly=64, holewidth=0;
	if (holex<-100) enemynumber=6, holewidth=0, enemydir=1;
	break;		
	}	
	
	if ((vbReadPad()&K_LL) && (craigx>0)) craigx--, craigdir=1;
	if ((vbReadPad()&K_LR) && (craigx<100)) craigx++, craigdir=2;	
	
	if ((vbReadPad()&K_LR) && (craigx>100))
	{
	craigx=100, bg1x=bg1x-2, bg2x=bg2x-2, holex=holex-2, craigdir=2, cloudtimer++;
	if (enemynumber<2) enemyboundary--;
	if (enemytype==4) enemyboundary--;	
	}

	if (cloudtimer>1) cloudtimer=0, bg3x--, bg4x--;
	if (fallinhole==0) moving();
	
	move_enemy();

	if (meter==18) reset_level_1();
	
	// if craig falls down the hole
	if (craigy>300) reset_level_1();	
	}
	
	}
	
int move_enemy()
	{

	switch (enemynumber)
	{
	case 1:
	enemyycuty=33;
	holexminussixteen=holex-16;		
	if ((enemyx>holexminussixteen) && (enemydir==2)) enemyx=holex-18, enemydir=1;	
	break;
	
	case 2:
	if (enemyx>holex+102) enemydir=1;	
	enemyboundary=holex+36;
	holewidth=152;
	break;	
	
	case 3:
	enemydir=0, holex=500, enemyxtotalx=16, enemyytotaly=15, fallinhole=0;
	if (iblockhit==0) enemyxcutx=64, enemyycuty=0, enemyy=120;
	
	if ((craigx>enemyx-12) && (craigx<enemyx+8))
	{
		if ((craigy==enemyy+16) && (iblockhit==0)) enemyycuty=16, iblockhit=1, enemyy=128, craigy=137, PlaySound(hit_iblock); // can
		if ((craigy==190) && (iblockhit==1)) iblockhit=2;
		if ((craigy==enemyy+8) && (iblockhit==2)) 
			{
			PlaySound(get_health);
			iblockhit=3;
			vbTextOut(3,9,0,"health - ;;;;"); // can gone and drank	
			meter=22, enemyy=400;
		}
	}
	break;
	
	case 4:
	holexminussixteen=holex-48;	
	enemyycuty=64, enemyytotaly=38, enemyy=craigy-24;
	if ((enemyx>holexminussixteen) && (enemydir==2)) enemyx--, enemydir1=1;	
	break;
	
	case 5:	
	holexminussixteen=holex+48;	
	holey=400;
	if ((enemyx>holexminussixteen) && (enemydir==2)) enemyx--, enemydir1=1;	
	enemyycuty=104, enemyytotaly=96, enemyxtotalx=39;	
	break;
	}
	
	if (enemyx<enemyboundary) enemydir1=2, enemydir=2;	
	
	if ((craigx>99) && (craigdir==2)) enemyx=enemyx-2;			
	if (enemydir==1) enemyx--; 
	if (enemydir==2) enemyx++;	
	
	enemyyminus=enemyy-16;
	enemyxplus=enemyx+12;
	enemyxminus=enemyx-12;	

	// enemytype- 1=strawberry, 2=item block, 3=cherry, 4=banana

	if ((craigy>enemyyminus) && (enemytype==1) && (enemyxcutx<64) && (craigx>enemyxminus) && (craigx<enemyxplus) && (hurttimer==0)) 
		{
		PlaySound(hurt);	
		meter--;
		vbTextOut(3,meter,0,"<");
		hurttimer++;
		}

	if ((craigy>enemyyminus) && (enemyycuty==64) && (hurttimer==0) && (enemytype==3)) 
		{
		if ((enemyanimtimer<88) && (craigx>enemyx) && (craigx<enemyx+8)) PlaySound(hurt), meter--, vbTextOut(3,meter,0,"<"), hurttimer++;		
	
		if ((enemyanimtimer>87) && (enemyanimtimer<132) && (craigx>enemyx) && (craigx<enemyx+8)) PlaySound(hurt), meter--, vbTextOut(3,meter,0,"<"), hurttimer++;		
		if ((enemyanimtimer>87) && (enemyanimtimer<132) && (craigx>enemyx+32) && (craigx<enemyx+48)) PlaySound(hurt), meter--, vbTextOut(3,meter,0,"<"), hurttimer++;
		
		if ((enemyanimtimer<176) && (enemyanimtimer>131) && (craigx>enemyx+32) && (craigx<enemyx+40)) PlaySound(hurt), meter--, vbTextOut(3,meter,0,"<"), hurttimer++;		
	
		if ((enemyanimtimer>175) && (craigx>enemyx) && (craigx<enemyx+8)) PlaySound(hurt), meter--, vbTextOut(3,meter,0,"<"), hurttimer++;		
		if ((enemyanimtimer>175) && (craigx>enemyx+32) && (craigx<enemyx+40)) PlaySound(hurt), meter--, vbTextOut(3,meter,0,"<"), hurttimer++;
		}

	if (hurttimer>0) hurttimer++;
	if (hurttimer>68) hurttimer=0;
	enemyanimtimer++;

	switch (enemytype)
	{
	case 1:
	if (enemyanimtimer>4) enemyanimtimer=0, enemyxcutx=enemyxcutx+16;
	if (enemyxcutx>48) enemyxcutx=0;
	break;
	
	case 3:
	if (enemyanimtimer==220) enemyanimtimer=44;
	if (enemyanimtimer==44) enemyxcutx=0, enemyxtotalx=39;
	if (enemyanimtimer==88) enemyxcutx=39, enemyxtotalx=47;
	if (enemyanimtimer==132) enemyxcutx=87, enemyxtotalx=39;
	if (enemyanimtimer==176) enemyxcutx=39, enemyxtotalx=47;
	break;

	case 4:
	if (enemyanimtimer==160) enemygravity=0, enemyxcutx=0, enemydir=enemydir1; 
	if (enemyanimtimer>160) enemyy--;
	if (enemyanimtimer>200) enemygravity++, enemyy=enemyy+enemygravity;
	if (enemyy>120) enemyy=120, enemyanimtimer=0, enemydir=0, enemyxcutx=42;	
	
	enemyxminus=enemyx-8, enemyxplus=enemyx+32;
	if ((craigy<enemyy+71) && (enemyxminus<craigx) && (hurttimer==0) && (enemyxplus>craigx)) PlaySound(hurt), meter--, vbTextOut(3,meter,0,"<"), hurttimer++;	
	break;
	}
	}
	
int reset_level_1()
	{
	craigx=20, craigy=190, fallinhole=0;
	jumpaheld=0, craigxtempo=1;
	holex=500, enemyy=175, enemyx=400;
	holewidth=32, holey=194;		
	iblockhit=0;
	enemyxcutx=0, enemyycuty=64, enemydir=1, enemyxtotalx=15, enemyytotaly=31;
	
	bg1x=0, bg2x=384, bg1cuty=95, bg2cuty=126, bg3x=0, bg3cuty=0, bg4x=384, bg4cuty=24;

	vbSetWorld(26, WRLD_ON|1, 0, 0, 194, 0, 0, 64, 384, 31); 	
	
	enemyanimtimer=0;// enemyy=120, enemydir=0;  // special for banana enemytype
	//enemyycuty=64;	
	
	StopAllSounds();
	PlaySound(levelone1);	
	PlaySound(levelone2);	
	
	enemynumber=1;
	
	lives--;	

	vbSetWorld(31, WRLD_ON|3, 104, 0, 8, 0, 0, 0, 175, 7); 	// title words
	lives_str[0]=(lives%10)+'0';	
	vbTextOut(3,0,0,": - ");	
	vbTextOut(3,4,0,lives_str);	
	vbTextOut(3,5,0,"    ");	
	
	meter=22;
	vbTextOut(3,9,0,"health - ;;;;");
	}	
	
int moving()
	{
	if (bg1x==-384) bg1cuty=bg1cuty+32, bg1x=384;
	if (bg2x==-384) bg2cuty=bg2cuty+32, bg2x=384;
	if (bg3x==-384) bg3cuty=bg3cuty+24, bg3x=384;		
	if (bg4x==-384) bg4cuty=bg4cuty+24, bg4x=384;		
	if (bg1cuty>125) bg1cuty=95;
	if (bg2cuty>157) bg2cuty=126;	
	if (bg3cuty>24) bg3cuty=0;
	if (bg4cuty>24) bg4cuty=0;	
	}
	
int controls()
	{
	if ((vbReadPad()&K_LL) && (craigx>0)) craigx=craigx-craigxtempo, craigdir=1, rolltimer++;
	
	if ((vbReadPad()&K_LR) && (craigx<368)) craigx=craigx+craigxtempo, craigdir=2, rolltimer++;

	if (jumptimer==0)
	{
	if ((rolltimer>2) && (craigdir==2)) rolltimer=0, craigcutx=craigcutx+16;
	if ((rolltimer>2) && (craigdir==1)) rolltimer=0, craigcutx=craigcutx-16;
	if (craigcutx>48) craigcuty=craigcuty+16, craigcutx=0;
	if (craigcuty>16) craigcuty=0, craigcutx=0;
	if (craigcutx<0) craigcutx=48, craigcuty=craigcuty-16;
	if (craigcuty<0) craigcuty=16, craigcutx=48;
	}
	
	// jumping
	if ((vbReadPad()&K_A) && (jumpaheld==0) && (gravity==0)) jumptimer++;
	
	if ((jumptimer>0) && (jumptimer<30)) craigy=craigy-2;
	
	// if A is no longer held
	if (!(vbReadPad()&K_A) && (jumptimer<30)) jumptimer=30;
	
	// if jumping reaches highest point
	if ((jumptimer==30) && (fallinhole==0)) jumptimer=30;	
	if ((jumptimer>30) && (fallinhole==0)) jumptimer=30;
	if (jumptimer>29) gravity++, craigy=craigy+gravity;
	
	if (gravity>6) gravity=6;
	if ((craigy>190) && (fallinhole==0)) craigy=190;
	if ((craigy==190) && (fallinhole==0)) jumpaheld=1;
	if ((craigy>189) && (fallinhole==1)) gravity++, craigy=craigy+gravity;

	// if jump is over and A is no longer held
	if (!(vbReadPad()&K_A) && (jumpaheld==1)) jumpaheld=0, gravity=0, jumptimer=0;
	}
	