
// This file contains sound and music notes.
//
// Each sound begins with the note length in video frames per note. To
// convert a tempo from beats per minute, use the following formula:
//
//   FramesPerNote = 50 / (BeatsPerMinute / 60)
//
// The result might not be an integer, so round up or down it as appropriate.
// It may not exceed 255 (which is about 11.75 beats per minute) because the
// FramesPerNote field of a tySound structure, where it gets copied to, is
// only 8 bits wide. It must also be larger than 1 (3000 beats per minute).
//
// The last note in the sound is either ENDSOUND, which stops the sound, or
// LOOPSOUND, which restarts it from the beginning.
	
const u16 titlescreen[] = {
   14,
   C_5, HOLD, HOLD, HOLD, G_4, HOLD, HOLD, HOLD, C_5, D_5, C_5, HOLD, E_5, HOLD, C_5, HOLD, D_5, HOLD, HOLD, HOLD, G_4, HOLD, HOLD, HOLD, D_5, E_5, G_4, HOLD, B_4, A_4, G_4, B_4,     
   C_4, HOLD, HOLD, HOLD, E_4, HOLD, HOLD, HOLD, C_4, B_3, A_3, HOLD, G_3, HOLD, A_3, HOLD, D_4, HOLD, HOLD, HOLD, G_3, HOLD, HOLD, HOLD, D_4, C_4, B_3, HOLD, G_3, HOLD, A_3, HOLD, 
   F_4, HOLD, HOLD, HOLD, C_4, HOLD, HOLD, HOLD, F_4, G_4, F_4, HOLD, A_4, HOLD, F_4, HOLD, G_4, HOLD, HOLD, HOLD, C_4, HOLD, HOLD, HOLD, G_4, A_4, F_4, HOLD, E_4, C_4, AS3, E_4,     
   F_4, HOLD, HOLD, HOLD, A_4, HOLD, HOLD, HOLD, F_4, E_4, D_4, HOLD, C_4, HOLD, D_4, HOLD, E_4, HOLD, HOLD, HOLD, C_4, HOLD, HOLD, HOLD, G_4, E_4, G_4, HOLD, C_4, HOLD, AS3, HOLD, 
LOOPSOUND,};

const u16 titlescreen2[] = {
   14,
   C_3, G_3, E_3, G_3, C_3, G_3, E_3, G_3, C_3, G_3, E_3, G_3, C_3, G_3, E_3, G_3, D_3, G_3, F_3, G_3, D_3, G_3, F_3, G_3, D_3, G_3, F_3, G_3, D_3, G_2, B_2, G_2, 
   C_5, G_5, E_5, G_5, C_5, G_5, E_5, G_5, C_5, G_5, E_5, G_5, C_5, G_5, E_5, G_5, D_5, G_5, F_5, G_5, D_5, G_5, F_5, G_5, D_5, G_5, F_5, G_5, D_5, G_5, F_5, G_5, 
   F_3, C_3, D_3, C_3, F_3, C_3, D_3, C_3, F_3, C_3, D_3, C_3, F_3, C_3, D_3, C_3, E_3, C_3, AS2, C_3, E_3, C_3, AS2, C_3, E_3, C_3, AS2, C_3, E_3, C_3, AS2, C_3, 
   F_5, C_5, D_5, C_5, F_5, C_5, D_5, C_5, F_5, C_5, D_5, C_5, F_5, C_5, D_5, C_5, E_5, C_5, AS4, C_5, E_5, C_5, AS4, C_5, E_5, C_5, AS4, C_5, E_5, C_5, AS4, F_4, 
LOOPSOUND,};

const u16 levelone1[] = {
   14,
   C_5, D_5, E_5, G_5, E_5, HOLD, HOLD, D_5, F_5, HOLD, HOLD, C_5, D_5, B_4, G_4, HOLD, C_5, D_5, E_5, F_5, G_5, A_5, G_5, E_5, F_5, G_5, E_5, HOLD, C_5, HOLD, HOLD, HOLD,
   D_5, E_5, FS5, A_5, FS5, HOLD, HOLD, D_5, G_5, HOLD, HOLD, D_5, E_5, CS5, A_4, HOLD, D_5, E_5, FS5, G_5, A_5, B_5, A_5, HOLD, G_5, HOLD, E_5, HOLD, C_5, HOLD, HOLD, HOLD,
   F_5, HOLD, C_5, HOLD, F_5, HOLD, C_5, HOLD, D_5, E_5, D_5, E_5, D_5, HOLD, HOLD, HOLD, F_5, HOLD, G_5, HOLD, A_5, HOLD, B_5, A_5, G_5, F_5, E_5, D_5, C_5, B_4, A_4, G_4,
   C_5, D_5, E_5, C_5, D_5, E_5, F_5, D_5, E_5, HOLD, F_5, HOLD, G_5, HOLD, C_6, HOLD, A_5, HOLD, HOLD, HOLD, D_5, HOLD, HOLD, HOLD, C_5, HOLD, B_4, HOLD, C_5, HOLD, G_4, B_4,
LOOPSOUND,};

const u16 levelone2[] = {
   14,
   C_3, G_3, G_2, G_3, C_3, G_3, G_2, G_3, F_3, A_3, C_4, A_3, D_3, B_2, G_2, B_2, C_3, G_3, G_2, G_3, C_3, G_3, G_2, G_3, C_3, G_3, G_2, G_3, C_3, G_3, G_2, G_3,
   D_3, A_3, A_2, A_3, D_3, A_3, A_2, A_3, G_3, B_3, B_2, B_3, C_3, A_2, C_3, B_2, D_3, A_3, A_2, A_3, D_3, B_2, A_2, A_3, G_3, B_3, B_2, B_3, C_3, G_3, G_2, G_3,
   F_3, A_3, C_4, A_3, F_3, A_3, C_4, A_3, D_3, C_3, D_3, E_3, D_3, C_3, D_3, E_3, F_3, A_3, C_4, A_3, D_3, A_3, B_3, HOLD, G_3, HOLD, E_3, HOLD, C_3, HOLD, G_3, HOLD, 
   C_3, G_3, G_2, G_3, C_3, G_3, G_2, G_3, A_3, C_4, A_3, D_3, B_2, G_2, C_3, G_2, A_2, D_3, A_3, D_3, G_3, D_4, G_3, D_3, C_3, G_3, G_2, G_3, C_3, G_3, G_2, G_3,
LOOPSOUND,};

const u16 stageintrosong[] = {
	40,
	C_4, E_4, G_4, AS4, C_5, HOLD, ENDSOUND};

const u16 stageintrosong2[] = {
	40,
	G_3, C_4, E_4, F_4, G_4,  HOLD, ENDSOUND};

const u16 stageintrosong3[] = {
	40,
	E_3, G_3, C_4, D_4, E_4,  HOLD, ENDSOUND};

const u16 hurt[] = {
	3,
	C_7, C_6, C_5, C_4, C_3, ENDSOUND};

const u16 jump[] = {
	3,
	C_2, D_3, E_4, F_5, G_6, ENDSOUND};

const u16 hit_iblock[] = {
	6,
	DS2, ENDSOUND};
	
const u16 get_health[] = {
	3,
	C_5, E_5, G_5, C_6, ENDSOUND};

const u16 silence[] = {
	1,
	C_0,ENDSOUND,};

